=== debian/changelog ===
cpptraj (5.1.0+dfsg-3build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:39:12 +1100

cpptraj (5.1.0+dfsg-3build2) noble; urgency=medium

  * No-change rebuild against libarpack2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 07:32:53 +0000

cpptraj (5.1.0+dfsg-3build1) mantic; urgency=medium

  * Rebuild against latest openmm

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 27 Jun 2023 14:04:24 -0400

cpptraj (5.1.0+dfsg-3) unstable; urgency=medium

  * Build with OpenMM on platforms which support OpenMM.
  * Build with libfftw3-dev.
  * Skip one more test case.

 -- Andrius Merkys <merkys@debian.org>  Thu, 24 Nov 2022 10:08:51 -0500

cpptraj (5.1.0+dfsg-2) unstable; urgency=medium

  * Adjust debian/watch to ignore old two-digit year number-based tags.
  * Run unittest during build.
  * Add autopkgtest.

 -- Andrius Merkys <merkys@debian.org>  Wed, 17 Aug 2022 02:50:24 -0400

cpptraj (5.1.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1017000)

 -- Andrius Merkys <merkys@debian.org>  Thu, 11 Aug 2022 03:14:45 -0400
