=== debian/changelog ===
cpptraj (5.1.0+dfsg-5) unstable; urgency=medium

  * Team upload.
  [ Adrian Bunk ]
  * Fix FTBFS with GCC 15. Closes: #1096471.
  [ Santiago Vila ]
  * Add debian/salsa-ci.yml.
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Sun, 21 Sep 2025 23:20:00 +0200

cpptraj (5.1.0+dfsg-4) unstable; urgency=medium

  * Stop the build on test failures.
  * Build with OpenMM support on armhf, mips64el and riscv64 as well.
  * Bump copyright years.

 -- Andrius Merkys <merkys@debian.org>  Mon, 13 May 2024 10:39:49 -0400
