=== debian/control ===
Source: cpptraj
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 gfortran,
 libarpack2-dev,
 libbz2-dev,
 libfftw3-dev,
 libnetcdf-dev,
 libopenmm-dev [amd64 arm64 armhf mips64el ppc64el riscv64],
 libreadline-dev,
 netcdf-bin <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://github.com/Amber-MD/cpptraj
Vcs-Browser: https://salsa.debian.org/debichem-team/cpptraj
Vcs-Git: https://salsa.debian.org/debichem-team/cpptraj.git

Package: cpptraj
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: fast, parallelized molecular dynamics trajectory data analysis
 CPPTRAJ is a program designed to process and analyze molecular dynamics
 trajectories and relevant data sets derived from their analysis. CPPTRAJ
 supports many popular MD software packages including Amber, CHARMM, Gromacs,
 and NAMD.
