=== debian/tests/control ===
Test-Command: mkdir bin && ln -s /usr/bin/cpptraj bin && make -C test test.complete summary
Depends:
 @,
 netcdf-bin, 
Restrictions:
 rw-build-tree,
