=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,repack,repacksuffix=+dfsg,dversionmangle=auto" \
 https://github.com/Amber-MD/cpptraj/tags \
 (?:.*?/)?v?(\d+\.\d+\.\d+)@ARCHIVE_EXT@
